// Skill Chain UI app by GhostInTheLeague

angular.module('beamng.apps')

.directive('skillChain', function () {
  return {
  templateUrl: '/ui/modules/apps/SkillChainApp/app.html',
  replace: true,
  restrict: 'EA',
  link: function Main($scope, element, attrs, ctrl) {      

    var streamsList = ['electrics', 'sensors', 'wheelInfo'];
    StreamsManager.add(streamsList);

    displaySkillScore = 0;
    $scope.displaySkillScoreString = '';
    $scope.displaySkillMultiplierString = '';

    $scope.currentSkillName = ''
    $scope.currentSkillScore = 0
    $scope.allSkillScore = 0 // current skill chain unmultiplied score
    $scope.skillMultiplier = 0.0

    $scope.prevSkillName = ''
    $scope.prevSkillScore = 0

    $scope.finalSkillScore = 0; // current skill chain ended, multiplied score is stored in this variable
    $scope.finalSkillScoreString = '' //stringified

    $scope.currentSkillImage = 'skillchain';

    maxSkillMultiplier = 5.0;

    enableAnimations = true;

    counterState = 0; //0 = standby, 1 = counting, 2 = showing final score
    counterStateCooldown = 0;

    skillPoints = 0;
    
    skillPointXPThreshold = 50000; //score to reach to get a new skill point
    skillPointXP = 0; // your current skill point

    
    skillPointXPOld = skillPointXP;
    skillPointXPNew = skillPointXP;
    // TODO: save skillPointXP and skillPoints 

    skillPointXPPercentage = 0;

    bottomElement = angular.element( document.querySelector('#SKA_bottom'));
    topElement = angular.element( document.querySelector('#SKA_top'));
    newSkillElement = angular.element( document.querySelector('#SKA_newskill'));
    oldSkillElement = angular.element( document.querySelector('#SKA_oldskill'));
    multElement = angular.element( document.querySelector('#SKA_mult'));
    finalScoreElement = angular.element( document.querySelector('#SKA_finalScore'));
    counterElement = angular.element( document.querySelector('#SKA_counter'));
    counterIconElement = angular.element( document.querySelector('#SKA_counterIcon'));
    counterCanvasElement = angular.element( document.querySelector('#SKA_counterCanvas'));

    skillCooldown = 1; //in seconds
    streakCooldown = 6; //in seconds
    blinking = 3 //s (3s before streakCooldown time)
    tSkillCooldown = 0; //0
    tStreakCooldown = 0;
    tBlinkingCooldown = 0;

    streakActive = true;

    skillChain = []
    skillChainIndex = 0;

    prevx = 0; 
    prevy = 0; 
    prevz = 0;
    prevAirspeed = 0;
    prevSkillId = -1;
    continuousDriftFrames = 0; //The drift will have to go on for X amount of frames before it gets counted. This filters out the 1-frame spikes.

    t = new Date(); 

    specialSkillStart = 7; //is it a nice solution? no. but it is what it is :P

    skillLevels = ['', 'Great ', 'Awesome ', 'Ultimate '];


    skills = [
      { //drift
        name: 'Drift',
        score: [100, 250, 500, 1000],
        category: 0,
        cooldown: 0,
        level: 0
      },
      { //e-drift
        name: 'E-Drift',
        score: [100, 250, 500, 1000],
        category: 0,
        cooldown: 0,
        level: 0
      },
      { //speed
        name: 'Speed', 
        score: [100, 250, 500, 1000],
        category: -1,
        cooldown: 0,
        resetCooldown: 0,
        level: 0
      },
      { //burnout
        name: 'Burnout',
        score: [50, 125, 250, 500],
        category: -1,
        cooldown: 0,
        level: 0
      },
      { //air
        name: 'Air',
        score: [100, 250, 500, 1000],
        category: -1,
        cooldown: 0,
        level: 0
      },
      { //two wheels
        name: 'Two wheels',
        score: [100, 250, 500, 1000],
        category: -1,
        cooldown: 0,
        level: -1
      },
      { //trading paint
        name: 'Trading Paint',
        score: [0,  1,    2,      3],
        category: -1
      },

      //  SPECIALS

      { //skill chain
        name: 'Skill Chain',
        score: [0, 1000, 1000, 1000], // (only great, awesome and ultimate)  5,000 | 10,000 | 20,000
        level: 0,
        icon: 'skillchain'
      },
      { //rollin
        name: 'They see me rollin\'',
        score: [500], 
        level: 0,
        cooldown: 0,
        icon: 'rollin'
      },
      { //drift tap
        name: 'Drift Tap',
        score: [1000],
        level: 0,
        cooldown: 0,
        icon: 'ebishu'
      },
      { //kangaroo
        name: 'Kangaroo',
        score: [1000],
        level: 0,
        count: 0, //needs to reach 3 separete air skills
        timeframe: 0, //set at first air skill. Needs to get 3 before this time
        cooldown: 0,
        icon: 'kangaroo'
      },
      { //hard charger
        name: 'Hard Charger',
        score: [1000],
        level: 0,
        cooldown: 0,
        timeframe: 0, //set at first burnout skill. Needs to get a speed skill before this time
        icon: 'hardcharger'
      },
      { //ebishu style
        name: 'Ebishu Style', //drift skill right after great air skill or better
        score: [1000],
        level: 0,
        cooldown: 0,
        timeframe: 0,
        icon: 'ebishu'
      }
    ];

    skill = {
      name : "Drift",
      score : 100, 
      level : 0,
      cooldown : 100
    };

    setUIstate(0);

    function defineSkill(skillNum, skillLevel, specialName = ''){
        return {
          num : skillNum,
          name : skillLevels[skillLevel] + skills[skillNum].name,
          score : skills[skillNum].score[skillLevel], 
          level : skillLevel,
          specialName : specialName
        };
    }

    function secondsFromNow(seconds) {
      let t = new Date();
      t.setMilliseconds( t.getMilliseconds() + Math.round(seconds*1000) );
      return t;
    }

    function addScore(skillName, skillPoints, specialIcon = '') {

      if ($scope.skillMultiplier < maxSkillMultiplier) {

        newMultiplier = Math.max(1.0, $scope.skillMultiplier + 0.1);

        if(enableAnimations) {
          multElement.addClass('SKA_multanim')
          setTimeout(function() { multElement.removeClass('SKA_multanim'); }, 400);
        }

      }

      if(enableAnimations){
        if (newSkillElement.hasClass('SKA_special')) {
          oldSkillElement.addClass('SKA_special')
        } else if(oldSkillElement.hasClass('SKA_special')){
          oldSkillElement.removeClass('SKA_special');
        }
      }

      $scope.prevSkillName = $scope.currentSkillName
      $scope.prevSkillScore =  $scope.currentSkillScore
      $scope.currentSkillName = skillName
      $scope.currentSkillScore = skillPoints

      $scope.skillMultiplier = parseFloat(newMultiplier.toFixed(1));

      $scope.allSkillScore += $scope.currentSkillScore;

      showNewSkill(skillName, skillPoints, specialIcon);
    }
    
    function showNewSkill(skillName, skillPoints, specialIcon = '') {
      // animations here

      if (specialIcon!=''){
        $scope.currentSkillImage = specialIcon;
        if (!newSkillElement.hasClass('SKA_special')){
          newSkillElement.addClass('SKA_special');
        }
      } else {
        newSkillElement.removeClass('SKA_special');
      }

      if(enableAnimations){
        newSkillElement.addClass('SKA_skillanim1')
        setTimeout(function() { newSkillElement.removeClass('SKA_skillanim1'); }, 400);
  
        oldSkillElement.addClass('SKA_skillanim2');
        setTimeout(function() { oldSkillElement.removeClass('SKA_skillanim2'); }, 400);
      }
    }

    function resetCounter() {
      prevSkillId = -1;

      $scope.displaySkillScore = 0;
      $scope.displaySkillScoreString = '';

      $scope.currentSkillName = ''
      $scope.currentSkillScore = 0
      $scope.allSkillScore = 0
      $scope.skillMultiplier = 0.0
  
      $scope.prevSkillName = ''
      $scope.prevSkillScore = 0
    }

    function performedSkill(skillNum, skillLevel, isSpecial = false) {

      if(counterState == 0) {
        resetCounter()
        tStreakCooldown = secondsFromNow(streakCooldown);

        counterState = 1; //active
        setUIstate(counterState);
      }
      prevSkillId = skillNum;
      let skill;
      isSpecial ? skill = defineSkill(skillNum,skillLevel, skills[skillNum].icon) : skill = defineSkill(skillNum,skillLevel);

      skillChain.push(skill)
      streakActive = true;
      bottomElement.removeClass('SKA_fading');
    }
    

    function getWheelsDownforce(wheelInfo) {
      //returns an array
      let wheelDownforceValues = [];
      for(var i in wheelInfo) {
        wheelDownforceValues.push(wheelInfo[i][7]);
      }
      return wheelDownforceValues;
    }


    function getWheelsOnGround(downforceValues) {
      let count = 0;
      for(var i in downforceValues) {
        if(downforceValues[i] > 700) {
          count++;
        }
      }
      return count;
    }

    function setUIstate(state) {

      switch(state) {
        case 0:

          counterIconElement.addClass('SKA_hidden');
          counterCanvasElement.addClass('SKA_hidden');
          finalScoreElement.addClass('SKA_hidden');
          
          counterIconElement.removeClass('SKA_counterIconAnim');
          counterCanvasElement.removeClass('SKA_counterCanvasAnim');
          finalScoreElement.removeClass('SKA_finalScoreAnim');

          topElement.addClass('SKA_hidden');
          bottomElement.addClass('SKA_hidden');

          topElement.removeClass('SKA_dropRight');
          bottomElement.removeClass('SKA_dropLeft');

          counterElement.removeClass('SKA_hidden');
          newSkillElement.removeClass('SKA_hidden');
          
          oldSkillElement.addClass('SKA_hidden');
 
          break;

        case 1:
          topElement.removeClass('SKA_hidden');
          bottomElement.removeClass('SKA_hidden'); 

          setTimeout(function() {
            oldSkillElement.removeClass('SKA_hidden');
          }, 500);

          break;

        case 2:
          topElement.removeClass('SKA_shake1');
          topElement.removeClass('SKA_shake2');
          topElement.removeClass('SKA_shake3');

          bottomElement.removeClass('SKA_fading');

          counterIconElement.removeClass('SKA_hidden');
          counterCanvasElement.removeClass('SKA_hidden');
          finalScoreElement.removeClass('SKA_hidden');

          counterIconElement.addClass('SKA_counterIconAnim');
          counterCanvasElement.addClass('SKA_counterCanvasAnim');
          finalScoreElement.addClass('SKA_finalScoreAnim');

          counterElement.addClass('SKA_hidden');
          newSkillElement.addClass('SKA_hidden');

          break;

          case 10:
            topElement.removeClass('SKA_shake1');
            topElement.removeClass('SKA_shake2');
            topElement.removeClass('SKA_shake3');
  
            bottomElement.removeClass('SKA_fading');
  
            topElement.addClass('SKA_dropRight');
            bottomElement.addClass('SKA_dropLeft');
  
            break;
      }

    }


    function drawCounterCanvas(percentage) {
      let canvas = document.getElementById("SKA_counterCanvas");
      let context = canvas.getContext("2d");
      context.clearRect(0, 0, canvas.width, canvas.height);
  
      // background
      let x = canvas.width*.5; 
      let y = canvas.height*.5; 
      let radius = 35; 
      let startAngle = Math.PI*0.78;
      let endAngle = Math.PI*0.22;
  
      context.beginPath();
      context.arc(x, y, radius, startAngle, endAngle, false);
      context.lineWidth = 11;
      context.strokeStyle = "#ffffffb3";
      context.stroke();
  

      // foreground
      x = canvas.width*.5; 
      y = canvas.height*.5; 
      radius = 35; 
      startAngle = Math.PI*0.78;
      endAngle = Math.PI*(-1.22 +1.44*percentage);
  
      context.beginPath();
      context.arc(x, y, radius, startAngle, endAngle, false);
      context.lineWidth = 11;
      context.strokeStyle = "#ffd932";
      context.stroke();
      
    }






    // This is called when the App gets removed from the screen:
    $scope.$on('$destroy', function () {
      StreamsManager.remove(streamsList);
      $scope.stop;
    });

                                                                                          ///////////////// STREAMS UPDATE /////////////////

    // To receive the data listen to the streamsUpdate event:
    $scope.$on('streamsUpdate', function (event, streams) {

      t = new Date();

      if (counterState == 0){
        streakActive = true;
      }

      let currentAirspeed = streams.electrics.airspeed*3.65
      let currentWheelspeed = streams.electrics.wheelspeed*3.65
      let wheelsDownforce = getWheelsDownforce(streams.wheelInfo);
      let wheelsCount = wheelsDownforce.length;
      let wheelsOnGround = getWheelsOnGround(wheelsDownforce);

      let endSkillChain = (t > tStreakCooldown && streakActive);
      let breakSkillChain = Math.abs(currentAirspeed-prevAirspeed) > 5.5 && prevAirspeed != 0


      if (t > tSkillCooldown && skillChain.length > 0) {

        if (skillChain.length > skillChainIndex) {

          addScore(skillChain[skillChainIndex].name, skillChain[skillChainIndex].score, skillChain[skillChainIndex].specialName)
          tSkillCooldown = secondsFromNow(skillCooldown);
          skillChainIndex++;

          tStreakCooldown = secondsFromNow(streakCooldown); //restart cooldown
          tBlinkingCooldown = secondsFromNow(streakCooldown*.5);

          streakActive = true
          // $scope.displaySkillScoreString = $scope.allSkillScore.toLocaleString('en-US');
          $scope.displaySkillMultiplierString = $scope.skillMultiplier.toFixed(1);

          $scope.$apply();

        }

      }

      if (breakSkillChain && counterState == 1) {
        skillChain = []
   
        skillChainIndex = 0;
        
        $scope.$apply();

        streakActive = false; //this will need to be re-enabled. While false, no skill will be counted.

        bottomElement.removeClass('SKA_fading');

        topElement.removeClass('SKA_shake1');
        topElement.removeClass('SKA_shake2');
        topElement.removeClass('SKA_shake3');

        // $scope.finalSkillScore = Math.round($scope.allSkillScore*$scope.skillMultiplier);
        // $scope.finalSkillScoreString = $scope.finalSkillScore.toLocaleString('en-US');


        skills[7].level = 0;

        counterState = 10; // break
        setUIstate(counterState);
        
        setTimeout(function() {
          counterState = 0; //reset
          resetCounter();
          setUIstate(counterState);
          streakActive = true;
        }, 6000);


        // tStreakCooldown = secondsFromNow(streakCooldown);
      }

      if(counterState == 2){

        if (skillPointXPNew > 0) {
          let xpGoal = Math.min(1, skillPointXPNew/skillPointXPThreshold)

          skillPointXPPercentage += (xpGoal - skillPointXPPercentage)*.1

        }

        drawCounterCanvas(skillPointXPPercentage)
      }

      if (t > tBlinkingCooldown && !bottomElement.hasClass('SKA_fading') && counterState == 1) {
        bottomElement.addClass('SKA_fading');
      }

      if (endSkillChain && counterState == 1) {

        $scope.finalSkillScore = Math.round($scope.allSkillScore*$scope.skillMultiplier);
        $scope.finalSkillScoreString = $scope.finalSkillScore.toLocaleString('en-US');
        $scope.$apply();

        skillPointXPPercentage = skillPointXP/skillPointXPThreshold
        
        skillPointXPOld = skillPointXP;
        skillPointXP += $scope.finalSkillScore;
        skillPointXPNew = skillPointXP;

        if (skillPointXP >= skillPointXPThreshold) {
          let skillPointCount = Math.floor( skillPointXP / skillPointXPThreshold )
          skillPoints += skillPointCount;
          skillPointXP = skillPointXP % skillPointXPThreshold;
          
        }
        console.log(' Skill Points: '+skillPoints);
        
        counterState = 2; //show final score
        setUIstate(counterState);
        streakActive = false;
        
        setTimeout(function() {
          counterState = 0; //reset
          setUIstate(counterState);
          streakActive = true;
        }, 3000);
      }
      
      /////////////////////////////////////// SKILLS ///////////////////////////////////////

      if (streakActive) {

        let level = 0
        let cooldown = 1;

        yaw = streams.sensors.yaw * (180.0 / Math.PI ) 
        angle = -1 * Math.atan2( (prevx - streams.sensors.position.x), (prevy - streams.sensors.position.y) ) * 180.0 / Math.PI;
        driftAngle = Math.abs(angle-yaw);


        let driftActive = (currentAirspeed > 25 && driftAngle >= 25 && driftAngle < 170) && (wheelsOnGround > 0)
        let speedActive = (currentAirspeed > 125 && wheelsOnGround > 0) 
        let burnoutActive = (currentWheelspeed > 25 && currentAirspeed < 10) && (wheelsOnGround > 0)
        let airActive = (wheelsOnGround == 0 && currentAirspeed > 20);
        let twoWheelsActive = (wheelsOnGround == 2 && wheelsCount > 2 && currentAirspeed > 5)

        // DRIFT
        if (driftActive) {
          continuousDriftFrames++;


          let whichSkill = 0; //0 = drift, 1 = e-drift, only visual difference
          cooldown = 1.25 //1.5

          if (t > skills[0].cooldown && continuousDriftFrames >= 5) {
            // Check if E-Drifting
            if (streams.electrics.parkingbrake >= 0.5) {
              whichSkill = 1;
            }

            level = skills[0].level;

            if (level < skillLevels.length) {
              performedSkill(whichSkill, level);
              skills[0].cooldown = secondsFromNow(cooldown);

              // ################ EBISHU STYLE SPECIAL || PERFORM ################ //
              if (t < skills[specialSkillStart+5].timeframe) {
                performedSkill(specialSkillStart+5, 0, true);
              }
              // ################ ------------------- ################ //
            }

            skills[0].level += 1
          }       


        } else {
          skills[0].level = 0
          continuousDriftFrames = 0;
        }

        // SPEED
        if (speedActive) {
          // 150, 225, 275 325
          

          // Resetting level if resetCooldown is met, else set the level to previous one
          (t > skills[2].resetCooldown) ? level = 0 : level = skills[2].level;

          if (currentAirspeed > 250 && level < 3) {
            level = 3
          }
          if (currentAirspeed > 200 && level < 2) {
            level = 2
          }
          if (currentAirspeed > 160 && level < 1) {
            level = 1
          }
          if (currentAirspeed > 125 && level == 0) {
            level = 0
          }



          if (t > skills[2].cooldown || level > skills[2].level) {
            performedSkill(2, level);
            skills[2].cooldown = secondsFromNow(50 - 45*(level==3));
            skills[2].resetCooldown = secondsFromNow(30 - 25*(level==3) );

            // ################ HARD CHARGER SPECIAL || PERFORM ################ //
            let __skillnum = specialSkillStart+4;

            if (t < skills[__skillnum].timeframe){

              performedSkill(__skillnum, 0, true)
              skills[__skillnum].timeframe = 0;

            }
            // ################ ------------------- ################ //
          }
          skills[2].level = level
        } else {
          skills[2].cooldown = Math.min(skills[2].cooldown, secondsFromNow(5));
          skills[2].resetCooldown = Math.min(skills[2].resetCooldown, secondsFromNow(5));
        }


        // BURNOUT
        if (burnoutActive) {

          if (t > skills[3].cooldown) {
            level = skills[3].level;
            cooldown = 1.5

            if (level < skillLevels.length) {
              performedSkill(3, level);
              skills[3].cooldown = secondsFromNow(cooldown);
            }

            // ################ HARD CHARGER SPECIAL || INIT ################ //
            if (level == 0){
              let __skillnum = specialSkillStart+4;
              skills[__skillnum].timeframe = secondsFromNow(6);
            }
            // ################ ------------------- ################ //

            skills[3].level += 1
          }

        } else {
          skills[3].level = 0
        }

        // AIR
        if (airActive) {

          if (t > skills[4].cooldown) {

            level = skills[4].level;
            cooldown = 0.5

            if (level < skillLevels.length) {
              performedSkill(4, level);
              skills[4].cooldown = secondsFromNow(cooldown);
            }

            // ################ EBISHU STYLE SPECIAL ################ //
            skills[specialSkillStart+5].timeframe = secondsFromNow(3);
            // ################ --------------- ################ //

            // ################ KANGAROO SPECIAL ################ //
            if (level == 0){ 
              let __skillnum = specialSkillStart+3;

              if( skills[__skillnum].count == 0){
                skills[__skillnum].timeframe = secondsFromNow(10);
              }  

              if (t <= skills[__skillnum].timeframe)
              {
                skills[__skillnum].count++;
              } else if(skills[__skillnum].count > 0) {
                skills[__skillnum].count = 0;
              }

              if (skills[__skillnum].count == 3) {
                performedSkill(__skillnum, 0, true);
              }
            }
            // ################ --------------- ################ //

            skills[4].level += 1
          }

        } else {
          skills[4].level = 0
        }


        // TWO WHEELS
        if (twoWheelsActive) {

          if (t > skills[5].cooldown) {
            level = skills[5].level;
            cooldown = 0.5 //default is 0.5

            if (level < skillLevels.length) {
              if(level >= 0) {
                performedSkill(5, level); //this is to make sure the skill has been performed for at least 1 second. it was too unforgiving without this.
                cooldown = 2
              }
              skills[5].cooldown = secondsFromNow(cooldown);
            }

            skills[5].level += 1
          }

        } else {
          skills[5].level = -1
        }

        //################################ SPECIALS ################################//

        // SKILLCHAIN
        if ($scope.allSkillScore >= 5000) {

          let __skillnum = specialSkillStart+0;

          level = skills[__skillnum].level;

          
          if ($scope.allSkillScore >= 5000 && level < 1) {
            level = 1
          }
          if ($scope.allSkillScore >= 10000 && level < 2) {
            level = 2
          }
          if ($scope.allSkillScore > 20000 && level < 3) {
            level = 3
          }


          if (level > skills[__skillnum].level) {


            if (level < skillLevels.length) {
              performedSkill(__skillnum, level, true);
            }

            topElement.addClass('SKA_shake'+level);

            skills[__skillnum].level = level
          }

        } else {
          let __skillnum = specialSkillStart+0;
          skills[__skillnum].level = 0;
        }

        // THEY SEE ME ROLLIN
        if (wheelsCount == 3 && wheelsOnGround == 1 && Math.abs(streams.sensors.roll) > .5 ) {

          let __skillnum = specialSkillStart+1;
          cooldown = 10;


          if (t > skills[__skillnum].cooldown) {


            if (level < skillLevels.length) {
              performedSkill(__skillnum, 0, true);
            }

            skills[__skillnum].cooldown = secondsFromNow(cooldown);
          }

        }




      } else {
        if (t > tStreakCooldown) {
          // streakActive = true;
        }
      }




      // Display Skill Score

      if(enableAnimations && displaySkillScore != $scope.allSkillScore){

        displaySkillScore += ($scope.allSkillScore - displaySkillScore)*0.2
        displaySkillScore = Math.round(displaySkillScore);

        if (displaySkillScore > $scope.allSkillScore-5) {
          displaySkillScore = $scope.allSkillScore
        }       

        $scope.displaySkillScoreString = displaySkillScore.toLocaleString('en-US');
        $scope.displaySkillMultiplierString = $scope.skillMultiplier.toFixed(1);

        $scope.$apply();
      } else{
        displaySkillScore = $scope.allSkillScore;
        $scope.displaySkillScoreString = displaySkillScore.toLocaleString('en-US');
        $scope.displaySkillMultiplierString = $scope.skillMultiplier.toFixed(1);
      }




      // Previous values
      prevx = streams.sensors.position.x;
      prevy = streams.sensors.position.y;
      prevz = streams.sensors.position.z;
      prevAirspeed = currentAirspeed;
    });






  }
};
});